# See the file "LICENSE" for the full license governing this code.
#
# frozen_string_literal: true

Facter.add('home_directories_not_owner_by_user') do
  confine kernel: 'Linux'

  setcode do
    Facter::Core::Execution.execute(<<~'CODE').split
      awk -F: '($1!~/(halt|sync|shutdown|nfsnobody)/ && $7!~/^(\/usr)?\/sbin\/nologin(\/)?$/ && $7!~/(\/usr)?\/bin\/false(\/)?$/) { print $1 " " $6 }' /etc/passwd | while read -r user dir; do
        if [ -d "$dir" ]; then
            owner=$(stat -L -c "%U" "$dir")
            if [ "$owner" != "$user" ]; then
              echo "$user"
            fi
        fi
      done
      CODE
  end
end


#!/usr/bin/env bash

