# See the file "LICENSE" for the full license governing this code.
#
# frozen_string_literal: true

require 'facter'
require 'etc'
#
# Determine incorrect configured host keys
#
Facter.add('incorrect_configured_private_host_keys') do
  confine kernel: 'Linux'

  setcode do
    Dir['/etc/ssh/ssh_host_*_key'].collect do |file|
      next file unless File.stat(file).uid == 0
      gid = File.stat(file).gid
      if gid == 0 # root
        next file unless File.stat(file).mode.to_s(8)[-4..-1] == '0600'
      else
        next file unless Etc.getgrgid(gid).name == 'ssh_keys'
        next file unless File.stat(file).mode.to_s(8)[-4..-1] == '0640'
      end
      nil
    end.compact
  end
end

