# See the file "LICENSE" for the full license governing this code.
#
# frozen_string_literal: true

require 'facter'
require 'etc'
#
# Determine incorrect configured host keys
#
Facter.add('incorrect_configured_public_host_keys') do
  confine kernel: 'Linux'

  setcode do
    Dir['/etc/ssh/ssh_host_*_key.pub'].collect do |file|
      next file unless File.stat(file).uid == 0
      next file unless File.stat(file).gid == 0
      next file unless File.stat(file).mode.to_s(8)[-4..-1] == '0644'
      nil
    end.compact
  end
end

