#
# See the file "LICENSE" for the full license governing this code.
#
# frozen_string_literal: true

require 'facter'
#
# Determine the priviliged commands
#
Facter.add('privileged_commands') do
  confine kernel: 'Linux'

  setcode do
    output = `
    for PARTITION in $(findmnt -n -l -k -it $(awk '/nodev/ { print $2 }' /proc/filesystems | paste -sd,) | grep -Pv "noexec|nosuid" | awk '{print $1}'); do
      for PRIVILEGED in $(find "${PARTITION}" -xdev -perm /6000 -type f); do
        echo ${PRIVILEGED}
      done
    done
    `.split
  end
end
