#
# See the file "LICENSE" for the full license governing this code.
#
# frozen_string_literal: true

require 'facter'
require 'puppet/type/yumrepo'
#
# Detect all repo's where gpg is disabled
#
Facter.add('repos_with_gpg_disabled') do
  confine kernel: 'Linux'

  setcode do
    repos = Puppet::Type::Yumrepo::ProviderInifile.instances
    repos.select {|r| r.gpgcheck != '1'}.collect {|r| r.name}
  end
end
