# See the file "LICENSE" for the full license governing this code.
#
# frozen_string_literal: true

require 'facter'
require 'etc'
#
# Determine incorrect configured sudo access
#
Facter.add('restricted_sudo_group') do
  confine kernel: 'Linux'

  setcode do
    line = Facter::Core::Execution.execute('grep -Pi \'^\\h*auth\\h+(?:required|requisite)\\h+pam_wheel\\.so\\h+(?:[^#\\n\\r]+\\h+)?((?!\\2)(use_uid\\b|group=\\H+\\b))\\h+(?:[^#\\n\\r]+\\h+)?((?!\\1)(use_uid\\b|group=\\H+\\b))(\\h+.*)?$\' /etc/pam.d/su')
    group = line.scan(/group=(.*)/).flatten.first
    next false unless group
    users = Facter::Core::Execution.execute("grep #{group} /etc/group").split(':')[3]
    users.nil?
  end
end
