# See the file "LICENSE" for the full license governing this code.
#
# frozen_string_literal: true

Facter.add('to_permissive_dot_files') do
  confine kernel: 'Linux'

  setcode do
    Facter::Core::Execution.execute(<<~'CODE').split
    awk -F: '($1!~/(halt|sync|shutdown|nfsnobody)/ && $7!~/^(\/usr)?\/sbin\/nologin(\/)?$/ && $7!~/(\/usr)?\/bin\/false(\/)?$/) { print $1 " " $6 }' /etc/passwd | while read -r user dir; do
      if [ -d "$dir" ]; then
          for file in "$dir"/.*; do
            if [ ! -h "$file" ] && [ -f "$file" ]; then
                fileperm=$(stat -L -c "%A" "$file")
                if [ "$(echo "$fileperm" | cut -c6)" != "-" ] || [ "$(echo "$fileperm" | cut -c9)" != "-" ]; then
                  echo "$file"
                fi
            fi
          done
      fi
    done
    CODE
  end
end
