# See the file "LICENSE" for the full license governing this code.
#
# frozen_string_literal: true

Facter.add('to_permissive_netrc_files') do
  confine kernel: 'Linux'

  setcode do
    Facter::Core::Execution.execute(<<~'CODE').split
    awk -F: '($1!~/(halt|sync|shutdown|nfsnobody)/ && $7!~/^(\/usr)?\/sbin\/nologin(\/)?$/ && $7!~/(\/usr)?\/bin\/false(\/)?$/) { print $1 " " $6 }' /etc/passwd | while read -r user dir; do
       if [ -d "$dir" ]; then
          file="$dir/.netrc"
          if [ ! -h "$file" ] && [ -f "$file" ]; then
             if stat -L -c "%A" "$file" | cut -c4-10 |  grep -Eq '[^-]+'; then
                echo "$file"
             fi
          fi
       fi
    done
    CODE
  end
end
