# See the file "LICENSE" for the full license governing this code.
#
# frozen_string_literal: true

require 'facter'
require 'etc'

# Determine users 

Facter.add('users_with_long_lock_periode') do
  confine kernel: 'Linux'

  setcode do
    user_lines =  Facter::Core::Execution.execute("awk -F: '/^[^#:]+:[^\\!\\*:]*:[^:]*:[^:]*:[^:]*:[^:]*:(\\s*|-1|3[1-9]|[4-9][0-9]|[1-9][0-9][0-9]+):[^:]*:[^:]*\\s*$/ {print $1\":\"$7}' /etc/shadow").split
    user_lines.collect do | user_line|
      user, lock = user_line.split(':')

      (lock.to_i <= 0 || lock.to_i > 30) ? user : nil
    end.compact
  end
end

