# See the file "LICENSE" for the full license governing this code.
#
# frozen_string_literal: true

require 'facter'
require 'etc'

# Determine users 

Facter.add('users_with_pwdchange_in_future') do
  confine kernel: 'Linux'

  setcode do
    Facter::Core::Execution.execute(<<~CODE).split
    awk -F: '/^[^:]+:[^!*]/{print $1}' /etc/shadow | while read -r usr; \
    do change=$(date -d "$(chage --list $usr | grep '^Last password change' | cut -d: -f2 | grep -v 'never$')" +%s); \
    if [[ "$change" -gt "$(date +%s)" ]]; then \
    echo $usr; fi; done    
    CODE
  end
end

