# See the file "LICENSE" for the full license governing this code.
#
# frozen_string_literal: true

require 'facter'
require 'etc'

# Determine users 

Facter.add('users_with_short_warning_periode') do
  confine kernel: 'Linux'

  setcode do
    user_lines =  Facter::Core::Execution.execute("grep -E ^[^:]+:[^\!*] /etc/shadow | cut -d: -f1,6").split
    user_lines.collect do | user_line|
      user, expiration = user_line.split(':')
      expiration.to_i >= 7 ? nil : user
    end.compact
  end
end

