# See the file "LICENSE" for the full license governing this code.
#
# frozen_string_literal: true

Facter.add('users_without_home_directory') do
  confine kernel: 'Linux'

  setcode do
    Facter::Core::Execution.execute(<<~'CODE').split
    awk -F: '($1!~/(halt|sync|shutdown|nfsnobody)/ && $7!~/^(\/usr)?\/sbin\/nologin(\/)?$/ && $7!~/(\/usr)?\/bin\/false(\/)?$/) { print $1 " " $6 }' /etc/passwd | while read -r user dir; do
      if [ ! -d "$dir" ]; then
         echo "$user"
      fi
    done
    CODE
  end
end

