#
# linux_secured::controls::nftables_loopback_traffic_is_configured
#
# @summary 
# Puppet controls are Puppet defined types that ensure a certain security control is implemented. Puppet changes the system in order to make the system compliant.## Description of the controlConfigure the loopback interface to accept traffic. Configure allother interfaces to deny traffic to the loopback network## RationaleLoopback traffic is generated between processes on machine and is typically critical to operation of the system. The loopback interface is the only place that loopback network traffic should be seen, all other interfaces should ignore traffic on this network as an anti- spoofing measure.## SkippingTo deliberately skip this control (e.g. meaning don't use Puppet to enforce this setting), we provideyou with two ways:1) Add `linux_secured::controls::nftables_loopback_traffic_is_configured: skip` to your hiera data. This will skip this control for **ALL** systems.  3) Add an entry with the content `nftables_loopback_traffic_is_configured` to the array value `linux_secured::skip_list` in your hiera data.  ## Excelent Compliance Solution.Puppet is an excellent solution to ensure your systems are CIS or STIG compliant. Now you're looking at information about only one compliance control, but managing total compliance isn't hard either! If you you like he prospect of easy way into continuous compliancy with minimal fuss and bother, we suggesttaking a look at [our solution](/docs/linux_secured/description.html) as your go-to option. Plus, our team can help you get up and running so that you can focus on other areas of your business. What are you waiting for? [Get started today!](/company/contact/)## BenchmarksThis control is used in the following benchmarks:- [Oracle Linux 8 CIS V2.0.0](/docs/linux_secured/cis/oraclelinux8_V2.0.0.html) - paragraph 3.4.2.7- [RedHat Enterprise Linux 8 CIS V2.0.0](/docs/linux_secured/cis/redhat_el8_V2.0.0.html) - paragraph 3.4.2.7
#
# @param title
#    The system identifier to apply the control to.
#    All controls need an system identifier to apply the control to. Here is a simple example:
#    ``` puppet
#    linux_secured::controls::control_name { 'host':}
#    ```
#    Althoug for `linux_secured` you can put anything in there, it is recommended that yuou use the string `host`.
#
#
# See the file "LICENSE" for the full license governing this code.
#
define linux_secured::controls::nftables_loopback_traffic_is_configured () {
  linux_secured_setup { "nftables_loopback_traffic_is_configured on ${title}":
    ensure => 'present',
  }

  alert('Specified CIS control is not yet automatically enforced.')
  # TODO: Find out why we get the Error: Could not process rule: No such file or directory
  # -> exec { "Enable nftables loopback traffic is configured for lo on ${title}":
  #   command => 'nft add rule inet filter input iif lo accept',
  #   unless  => "nft list ruleset | awk '/hook input/,/}/' | grep 'iif \"lo\" accept'",
  #   path    => ['/usr/sbin/', '/usr/bin'],
  # }

  # -> exec { "Enable nftables loopback traffic is configured for 127.0.0.0 on ${title}":
  #   command => 'nft create rule inet filter input ip saddr 127.0.0.0/8 counter drop',
  #   unless  => "nft list ruleset | awk '/hook input/,/}/' | grep 'ip saddr'",
  #   path    => ['/usr/sbin/', '/usr/bin'],
  # }

  # if $facts['ip6_enabled'] == true {
  #   exec { "Enable nftables loopback traffic is configured for IPV6 ::1 on ${title}":
  #     command => 'nft add rule inet filter input ip6 saddr ::1 counter dr',
  #     unless  => "nft list ruleset | awk '/hook input/,/}/' | grep 'ip6 saddr'",
  #     path    => ['/usr/sbin/', '/usr/bin'],
  #     require => Linux_secured_setup["nftables_loopback_traffic_is_configured on ${title}"],
  #   }
  # }
}
