class linux_secured::fact_caching (
  Boolean   $enabled,
  String[1] $contains_sudo_noauthenticate_rules_ttl,
  String[1] $contains_sudo_nopasswd_rules_ttl,
  String[1] $contains_sudo_timestamp_timeout_ttl,
  String[1] $forward_files_ttl,
  String[1] $home_directories_not_owner_by_user_ttl,
  String[1] $incorrect_configured_private_host_keys_ttl,
  String[1] $incorrect_configured_public_host_keys_ttl,
  String[1] $netrc_files_ttl,
  String[1] $privileged_commands_ttl,
  String[1] $repos_with_gpg_disabled_ttl,
  String[1] $restricted_sudo_group_ttl,
  String[1] $rhosts_files_ttl,
  String[1] $system_accounts_wih_invalid_shell_ttl,
  String[1] $system_accounts_with_usable_password_ttl,
  String[1] $to_permissive_dot_files_ttl,
  String[1] $to_permissive_netrc_files_ttl,
  String[1] $to_permissve_home_directories_ttl,
  String[1] $ungrouped_files_and_directories_ttl,
  String[1] $unowned_files_and_directories_ttl,
  String[1] $users_with_long_expiration_ttl,
  String[1] $users_with_long_lock_periode_ttl,
  String[1] $users_with_pwdchange_in_future_ttl,
  String[1] $users_with_short_expiration_ttl,
  String[1] $users_with_short_warning_periode_ttl,
  String[1] $users_without_home_directory_ttl,
  String[1] $users_without_password_ttl,
  String[1] $world_writable_files_ttl,
) {
  if $enabled {
    fact_config { 'contains_sudo_noauthenticate_rules':
      ttl => $contains_sudo_noauthenticate_rules_ttl,
    }

    fact_config { 'contains_sudo_nopasswd_rules':
      ttl => $contains_sudo_nopasswd_rules_ttl,
    }

    fact_config { 'contains_sudo_timestamp_timeout':
      ttl => $contains_sudo_timestamp_timeout_ttl,
    }

    fact_config { 'forward_files':
      ttl => $forward_files_ttl,
    }

    fact_config { 'home_directories_not_owner_by_user':
      ttl => $home_directories_not_owner_by_user_ttl,
    }

    fact_config { 'incorrect_configured_private_host_keys':
      ttl => $incorrect_configured_private_host_keys_ttl,
    }

    fact_config { 'incorrect_configured_public_host_keys':
      ttl => $incorrect_configured_public_host_keys_ttl,
    }

    fact_config { 'netrc_files':
      ttl => $netrc_files_ttl,
    }

    fact_config { 'privileged_commands':
      ttl => $privileged_commands_ttl,
    }

    fact_config { 'repos_with_gpg_disabled':
      ttl => $repos_with_gpg_disabled_ttl,
    }

    fact_config { 'restricted_sudo_group':
      ttl => $restricted_sudo_group_ttl,
    }

    fact_config { 'rhosts_files':
      ttl => $rhosts_files_ttl,
    }

    fact_config { 'system_accounts_wih_invalid_shell':
      ttl => $system_accounts_wih_invalid_shell_ttl,
    }

    fact_config { 'system_accounts_with_usable_password':
      ttl => $system_accounts_with_usable_password_ttl,
    }

    fact_config { 'to_permissive_dot_files':
      ttl => $to_permissive_dot_files_ttl,
    }

    fact_config { 'to_permissive_netrc_files':
      ttl => $to_permissive_netrc_files_ttl,
    }

    fact_config { 'to_permissve_home_directories':
      ttl => $to_permissve_home_directories_ttl,
    }

    fact_config { 'ungrouped_files_and_directories':
      ttl => $ungrouped_files_and_directories_ttl,
    }

    fact_config { 'unowned_files_and_directories':
      ttl => $unowned_files_and_directories_ttl,
    }

    fact_config { 'users_with_long_expiration':
      ttl => $users_with_long_expiration_ttl,
    }

    fact_config { 'users_with_long_lock_periode':
      ttl => $users_with_long_lock_periode_ttl,
    }

    fact_config { 'users_with_pwdchange_in_future':
      ttl => $users_with_pwdchange_in_future_ttl,
    }

    fact_config { 'users_with_short_expiration':
      ttl => $users_with_short_expiration_ttl,
    }

    fact_config { 'users_with_short_warning_periode':
      ttl => $users_with_short_warning_periode_ttl,
    }

    fact_config { 'users_without_home_directory':
      ttl => $users_without_home_directory_ttl,
    }

    fact_config { 'users_without_password':
      ttl => $users_without_password_ttl,
    }

    fact_config { 'world_writable_files':
      ttl => $world_writable_files_ttl,
    }
    include linux_secured::clear_caches
  } else {
    #
    # On puppet versions older than V6, the required libs
    # for fact_config are not installed. Because it also doesn't
    # serve any purpose, we skip this part on those versions.
    #
    if versioncmp($clientversion, '6.0.0') != -1 {
      #
      # Disable fact caching for all ora_install facts
      #
      $linux_secured_facts = [
        'contains_sudo_noauthenticate_rules',
        'contains_sudo_nopasswd_rules',
        'contains_sudo_timestamp_timeout',
        'forward_files',
        'home_directories_not_owner_by_user',
        'incorrect_configured_private_host_keys',
        'incorrect_configured_public_host_keys',
        'netrc_files',
        'privileged_commands',
        'repos_with_gpg_disabled',
        'restricted_sudo_group',
        'rhosts_files',
        'system_accounts_wih_invalid_shell',
        'system_accounts_with_usable_password',
        'to_permissive_dot_files',
        'to_permissive_netrc_files',
        'to_permissve_home_directories',
        'ungrouped_files_and_directories',
        'unowned_files_and_directories',
        'users_with_long_expiration',
        'users_with_long_lock_periode',
        'users_with_pwdchange_in_future',
        'users_with_short_expiration',
        'users_with_short_warning_periode',
        'users_without_home_directory',
        'users_without_password',
        'world_writable_files',
      ]

      fact_config { $linux_secured_facts:
        ttl => absent,
      }
    }
  }
}
