# Disable and blacklist a module
define linux_secured::internal::disable_module (
  Enum['true', 'false'] $install_status,
  Boolean               $blacklist,
) {
  $content = if $blacklist {
    "install ${title} /bin/${install_status}\nblacklist ${title}"
  } else {
    "install ${title} /bin/${install_status}"
  }

  file { "/etc/modprobe.d/${title}.conf":
    ensure  => 'file',
    content => $content,
    owner   => 'root',
    group   => 'root',
    mode    => '0644',
  }
  ~> exec { "unload module ${title}":
    command     => "/sbin/modprobe -r ${title}",
    refreshonly => true,
  }
}
