# Disable and blacklist a module
define linux_secured::internal::validate_module (
  Boolean               $skip,
  String[1]             $report_as,
  String[1]             $control,
  Enum['true', 'false'] $install_status,
) {
  validation { "module is ${title} not loaded":
    check           => "lsmod | grep ${title}",
    path            => ['/usr/sbin/', '/usr/bin'],
    expected_output => '',
    control         => $control,
    skip            => $skip,
    report_as       => $report_as,
    fail_message    => "Module ${title} should NOT be loaded",
  }

  validation { "module ${title} is not beeing installed at boot":
    check           => "modprobe -n -v ${title} | grep -E '(${title}|install)'",
    path            => ['/usr/sbin/', '/usr/bin'],
    expected_output => Regexp("install /bin/${install_status}"),
    control         => $control,
    skip            => $skip,
    report_as       => $report_as,
    fail_message    => "Module ${title} should NOT be installed at boot, but it IS",
  }
}
