define linux_secured::internal::validate_mount_option (
  Boolean   $skip,
  String[1] $report_as,
  String[1] $control
) {
  $parts = $title.split('@')
  $partition = $parts[0]
  $option    = $parts[1]

  validation { "${option} option is set on ${partition} partition":
    check           => "findmnt --kernel ${partition} | grep ${option}",
    path            => ['/usr/sbin/', '/usr/bin'],
    expected_output => Regexp($option),
    control         => $control,
    skip            => $skip,
    report_as       => $report_as,
    fail_message    => "${partition} should be a mounted with the ${option} option, but it is NOT.",
  }
}
